#include <p18F4520.h>
#include<stdio.h>
#include<string.h>
#include <i2c.h>
#include <lcd_picdem2_2008.h>
#include <delays.h>
#include "I2CRTC.h"

static ram tTimeDate 		initTimeDate;
static ram tTimeDate		currentTimeDate;
union uControl 	control;
unsigned char 	ctrl;

char strtest[16]="bonjour jose";
char display[32]="";

int seconds, minutes, hours, date, month, year;

void main()
{
	OpenI2C(MASTER, SLEW_OFF);// Initialize I2C module
	SSPADD = 9;				// put the bus frequency to 100 kHz
 
	init_LCD();
	initTimeDate.sec.seconds8b=0x0;
	initTimeDate.min.minutes8b=0x0;
	initTimeDate.hours.hours8b=0x0;
	initTimeDate.day.day8b=0x0;
	initTimeDate.date.dateFields.DATE=9;
	initTimeDate.date.dateFields.TEN_DATE=0;
	initTimeDate.month.monthFields.MONTH=2;
	initTimeDate.month.monthFields.TEN_MONTH=0;
	initTimeDate.year.yearFields.YEAR=0;
	initTimeDate.year.yearFields.TEN_YEAR=1;
	
	startRTC();						// start the RTC
	setRTCAdressTo(0);				// starting from address 0
	initializeRTC(&initTimeDate); 
	control.control8b = 0x03;
	writeControl(control.control8b);
	
	while(1)
	{
		writeControl(control.control8b);
		ctrl = readControl();
		//initializeRTC(&initTimeDate); 
		//chaintxtRam((ram char*)strtest,0);
		setRTCAdressTo(0);
		Delay1KTCYx(15);
		readRTC(&currentTimeDate);
		seconds = 10*currentTimeDate.sec.secondsFields.TEN_SECONDS + currentTimeDate.sec.secondsFields.SECONDS;
		minutes = 10*currentTimeDate.min.minutesFields.TEN_MINUTES + currentTimeDate.min.minutesFields.MINUTES;
		hours = 10*currentTimeDate.hours.hours24Fields.TEN_HR + currentTimeDate.hours.hours24Fields.HOURS;
		date = 10*currentTimeDate.date.dateFields.TEN_DATE + currentTimeDate.date.dateFields.DATE;
		month = 10*currentTimeDate.month.monthFields.TEN_MONTH + currentTimeDate.month.monthFields.MONTH;
		year= 2000 + 10*currentTimeDate.year.yearFields.TEN_YEAR + currentTimeDate.year.yearFields.YEAR;
		sprintf(display,"%d:%d:%d:%d:%d:%d", seconds, minutes, hours, date, month, year);
		chaintxtRam((ram char*)display,0);
	}

}